import numpy as np
import serial
import time
import matplotlib.pyplot as plt
import fingerprint_enhancer
import cv2 

from PIL import Image, ImageOps


# replace space to new line
def create_np_array(file_name):

    temps = []
    with open(file_name, "r") as r:
        with open("fpData/temp.txt", "w") as w:
            w.write(r.read().replace(' ' , '\n'))

    # Open text file and write to temp list
    f = open('fpData/temp.txt')
    for line in f.readlines():

        try:
            temps.append(int(line.strip()))
        except:
            print("Space")

    f.close()


    '''
    ser = serial.Serial('com12', 115200, timeout = 0.1)
    time.sleep(0.2)

    for i in range(25600):
        line = ser.readline()
        if line:
            string = line.decode()
            num = int(string)
            print(num, end = ' ')
            temps.append(int(string))

    ser.close()
    '''
    # print(temps)

    # Store list into numpy array 
    fp_array = np.array(temps)

    # print(fp_array)

    print(type(fp_array))

    print(len(fp_array))

    return (fp_array)


# Display array
def display_fp(fp_arr):
    # Construct image from data
    w,h = 240, 240

    t=(h,w,3)

    fp_sample=np.zeros(t, dtype=np.uint8)
    for index,value in enumerate(fp_arr): 
        a = int( index % 160  )
        b = int( index / 160  )
        # fp_sample[a,b] = [40+a, 80+b, int(value)]
        fp_sample[a,b] = [10+a, 20+b, int(value)]

    i = Image.fromarray(fp_sample)
    i.show()
    
    i.save("Img/temp.png")
    og_image = Image.open("Img/temp.png")
    gray_image= ImageOps.grayscale(og_image)
    gray_image.save("Img/temp.png")
     # gray_image.show("img/temp.png")

    '''
    img = cv2.imread("Img/temp.png", 0)
    out = fingerprint_enhancer.enhance_Fingerprint(img)
    cv2.imshow('enhanced_image', out);      # display the result 
    cv2.waitKey(0)
    '''
    # Plot on xy axis
    '''
    x = np.arange(0,25600)
    y = fp_array[x]

    plt.plot(x, y, color = 'red')
    plt.show()
    '''
if __name__ == '__main__':

    fp_array1 = create_np_array("fpData/RawData2.txt")
   # fp_array2 = create_np_array("fpData/RawData6.txt")

    display_fp(fp_array1)
   # display_fp(fp_array2)

