'''
Merge all image to print as single image 
'''

import numpy as np 
import matplotlib.pyplot as plt
import fingerprint_enhancer

from IPython.display import clear_output
from skimage.morphology import skeletonize

# remove dot function for thinning fp image 
def removedot(invertThin):
    temp0 = np.array(invertThin[:])
    temp0 = np.array(temp0)
    temp1 = temp0/255
    temp2 = np.array(temp1)
    temp3 = np.array(temp2)

    enhanced_img = np.array(temp0)
    filter0 = np.zeros((10,10))
    W,H = temp0.shape[:2]
    filtersize = 6

    for i in range(W - filtersize):
        for j in range(H - filtersize):
            filter0 = temp1[i:i + filtersize,j:j + filtersize]

            flag = 0
            if sum(filter0[:,0]) == 0:
                flag +=1
            if sum(filter0[:,filtersize - 1]) == 0:
                flag +=1
            if sum(filter0[0,:]) == 0:
                flag +=1
            if sum(filter0[filtersize - 1,:]) == 0:
                flag +=1
            if flag > 3:
                temp2[i:i + filtersize, j:j + filtersize] = np.zeros((filtersize, filtersize))

    return temp2

# plot fp sample
def plot_sample(fp_image,x,y):
    '''
    plot the given sample
    '''
    print(fp_image)
    print(fp_image.shape)
    fp_enhance_image= fingerprint_enhancer.enhance_Fingerprint(fp_image)

    fp_enhance_image[fp_enhance_image == 255] =1

    skeleton = skeletonize(fp_enhance_image)
    skeleton = np.array(skeleton, dtype=np.uint8)
    skeleton = removedot(skeleton)

    plt.subplot(x,2,y)
    plt.imshow(skeleton, 'gray')

# extract sub array
def extract_sample(arry,x,y):
    '''
    plot the given sample
    '''
    fp_sample = arry[0:120,0:120]
    
    print(fp_sample)
    fp_image = np.reshape(fp_sample, (120, 120))    
    
    print(fp_image.shape)

    
    # fp_image = np.array(fp_sample).reshape(32,32)

    fp_enhance_image= fingerprint_enhancer.enhance_Fingerprint(fp_image)

    fp_enhance_image[fp_enhance_image == 255] =1

    skeleton = skeletonize(fp_enhance_image)
    skeleton = np.array(skeleton, dtype=np.uint8)
    skeleton = removedot(skeleton)
    
    print(skeleton)
    plt.subplot(x,2,y)
    plt.imshow(skeleton, 'gray')
    

# plot fp samples 
def plot_samples(fp_image, x, y):
    '''
    plot the given sample
    '''
    fp_enhance_image= fingerprint_enhancer.enhance_Fingerprint(fp_image)

    fp_enhance_image[fp_enhance_image == 255] =1

    skeleton = skeletonize(fp_enhance_image)
    skeleton = np.array(skeleton, dtype=np.uint8)
    skeleton = removedot(skeleton)

    print(skeleton)
    plt.subplot(x,4,y)
    plt.imshow(skeleton, 'gray')
    # plt.show()


# main function 
if __name__ == "__main__":

    # Read fp data from the text file

    temps = np.loadtxt("fpData/fp_image.txt")
    # print(temps)
    
    # shaping array as pixels 160x160 i.e, 25600 samples
    arr1 = np.array(temps[0]).reshape(160,160)
    arr2 = np.array(temps[1]).reshape(160,160)
    arr3 = np.array(temps[2]).reshape(160,160)
    arr4 = np.array(temps[3]).reshape(160,160)
    
    arr5 = np.array(temps[4]).reshape(160,160)
    arr6 = np.array(temps[5]).reshape(160,160)
    arr7 = np.array(temps[6]).reshape(160,160)
    arr8 = np.array(temps[7]).reshape(160,160)

    plot_sample(arr1, 1, 1)
    
    extract_sample(arr1, 1, 2)

    '''
    # plot samples 
    plot_samples(arr1,2,1)
    plot_samples(arr2,2,2)
    plot_samples(arr3,2,3)
    plot_samples(arr4,2,4)

    plot_samples(arr5,2,5)
    plot_samples(arr6,2,6)
    plot_samples(arr7,2,7)
    plot_samples(arr8,2,8)
  
    '''
    plt.show()
    
    
    # Merging all samples to single array 

    '''
    fp_array1 = np.concatenate((arr1,arr2), axis=1)
    fp_array2 = np.concatenate((arr3,arr4), axis=1)

    fp_array = np.concatenate((fp_array1, fp_array2), axis =0)

    fp_image = np.reshape(fp_array, (320,320))

    fp_enhance_image= fingerprint_enhancer.enhance_Fingerprint(fp_image)

    fp_enhance_image[fp_enhance_image == 255] =1

    skeleton = skeletonize(fp_enhance_image)
    skeleton = np.array(skeleton, dtype=np.uint8)
    skeleton = removedot(skeleton)

    plt.imshow(skeleton, 'gray')
    plt.show()
    '''
