import numpy as np
import serial
import time
import matplotlib.pyplot as plt
import fingerprint_enhancer

from IPython.display import clear_output
from skimage.morphology import skeletonize

# remove dot function for thinning fp image 
def removedot(invertThin):
    temp0 = np.array(invertThin[:])
    temp0 = np.array(temp0)
    temp1 = temp0/255
    temp2 = np.array(temp1)
    temp3 = np.array(temp2)

    enhanced_img = np.array(temp0)
    filter0 = np.zeros((10,10))
    W,H = temp0.shape[:2]
    filtersize = 6

    for i in range(W - filtersize):
        for j in range(H - filtersize):
            filter0 = temp1[i:i + filtersize,j:j + filtersize]

            flag = 0
            if sum(filter0[:,0]) == 0:
                flag +=1
            if sum(filter0[:,filtersize - 1]) == 0:
                flag +=1
            if sum(filter0[0,:]) == 0:
                flag +=1
            if sum(filter0[filtersize - 1,:]) == 0:
                flag +=1
            if flag > 3:
                temp2[i:i + filtersize, j:j + filtersize] = np.zeros((filtersize, filtersize))

    return temp2

# create a temp list to store values

samples : int = 0
temps = [[],[],[],[],[],[],[],[]] 

while samples<8: 
    clear_output(wait=True)
    ser = serial.Serial('com12', 9600, timeout = 0.1)
    time.sleep(0.2)

    print('Place your finger on sensor')
    #ser.write(b'FF')
    while (ser.readline().decode() == ""):
        #if print(ser.readline().decode() == ""):
         #   print("No data on serialport")
         time.sleep(0.01)

    print('Please wait while collection data')
    for i in range(25600):
        line = ser.readline()
        if line:
            string = line.decode()
            # num = int(string)
            # print(num, end = ' ')
            temps[samples].append(int(string))
   
    ser.close()
    samples +=1
    
for samples in range(8):
    # print(temps)

    # Store list into numpy array 
    fp_array = np.array(temps[samples])

    # construct image from data 
    fp_image = np.reshape(fp_array, (160,160))
    
    # enhance fp image  
    fp_enhance_image = fingerprint_enhancer.enhance_Fingerprint(fp_image)
    
    # thinning enhaced image 
    fp_enhance_image[fp_enhance_image == 255] =1 
    

    skeleton = skeletonize(fp_enhance_image)
    skeleton = np.array(skeleton, dtype=np.uint8)
    skeleton = removedot(skeleton)
    
    plt.imshow(skeleton, 'gray')
    plt.show()
    

# saveing array in a text file 
np.savetxt("fpData/fp_image.txt", temps)


